%------------------------------------------------------------------------------------------------
% calculate mean Inra-variability across 2 runs on fsaverage4 (2562 vertices on each hemisphere)
% 2019,09,04 update
%------------------------------------------------------------------------------------------------


clear,clc,close all
SIDs = textread(['/autofs/space/bidlin11_003/users/sleep_data/Lists/Sleep_List_TwoBold.txt'],'%s');

OUT_DIR=(['/autofs/space/bidlin11_003/users/sleep_data/Results/Variability']);
mkdir([OUT_DIR]);

%% load corr.mat of the same subject from different sessions
path_test = ['/autofs/space/bidlin11_003/users/sleep_data/Results/Corr_results_test'];
path_retest = ['/autofs/space/bidlin11_003/users/sleep_data/Results/Corr_results_retest'];

%% load file to extract vertices on cortex (not in midline)
LV = textread('/autofs/space/bidlin11_001/users/Share/Templates/Surf/fsaverage4/label/lh.cortex.label', '','headerlines',2);
RV = textread('/autofs/space/bidlin11_001/users/Share/Templates/Surf/fsaverage4/label/rh.cortex.label', '','headerlines',2);
cortex = [LV(:,1)+1;RV(:,1)+1+2562];


for s=1:length(SIDs)  % for each subject
    
    s 
    subname = SIDs{s};
    
    %% session1, test
    load([path_test,'/CECE_', subname, '_lh_to_lh.mat']);
    LL_corr=corr_mat;

    load([path_test,'/CECE_', subname, '_lh_to_rh.mat']);
    LR_corr=corr_mat;
    
    load([path_test,'/CECE_', subname, '_rh_to_lh.mat']);
    RL_corr=corr_mat;

    load([path_test,'/CECE_', subname, '_rh_to_rh.mat']);
    RR_corr=corr_mat;
       
    CC_Big1 =[LL_corr LR_corr; RL_corr RR_corr];
 

   %% session2, re-test
    load([path_retest,'/CECE_', subname, '_lh_to_lh.mat']);
    LL_corr=corr_mat;

    load([path_retest,'/CECE_', subname, '_lh_to_rh.mat']);
    LR_corr=corr_mat;
    
    load([path_retest,'/CECE_', subname, '_rh_to_lh.mat']);
    RL_corr=corr_mat;

    load([path_retest,'/CECE_', subname, '_rh_to_rh.mat']);
    RR_corr=corr_mat;
       
    CC_Big2 =[LL_corr LR_corr; RL_corr RR_corr];
   
%-------------------------------------------------------------------------
%% calculate Stability and Variability for each subjects separately
%-------------------------------------------------------------------------
    CC_Big1 = CC_Big1(cortex,cortex); CC_Big2 = CC_Big2(cortex,cortex);
    Variability(s,:) = 1-my_matcorr(CC_Big1,CC_Big2);
    
end

%------------------------------------------------------------------------ 
%% save the mean variability across all subjects 
%% (will be regressed for final inter-variability)
%-------------------------------------------------------------------------
mean_Intra_Vari=mean(Variability, 1);
z_mean_Intra_Vari=zscore(mean_Intra_Vari);



Map = zeros(1,5124);Map(cortex) = mean_Intra_Vari;
save_mgh(Map(1:2562),[OUT_DIR,'/LH_mean_Intra_Variability.mgh'], eye(4));
save_mgh(Map(2563:end),[OUT_DIR,'/RH_mean_Intra_Variability.mgh'], eye(4));


Map = zeros(1,5124);Map(cortex) = z_mean_Intra_Vari;
save_mgh(Map(1:2562),[OUT_DIR,'/z_LH_mean_Intra_Variability.mgh'], eye(4));
save_mgh(Map(2563:end),[OUT_DIR,'/z_RH_mean_Intra_Variability.mgh'], eye(4));


